#include <GlewOpenGL.h>
#include "Renderable.h"
#include <math.h>
#if defined(__APPLE__)
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
namespace apig {

/*********************************************************************************************/
// RenderableCube implementation :

float RenderableCube::radius() const { return c * sqrtf(3.0f / 4.0f); }

void RenderableCube::render() const {
    const float r = c / 2.0f;

    glBegin(GL_QUADS);
        // face superieure :
        glNormal3f(0,0,1);
        glVertex3f(-r,-r, r);
        glVertex3f( r,-r, r);
        glVertex3f( r, r, r);
        glVertex3f(-r, r, r);
        
        // face inferieure :
        glNormal3f(0,0,-1);
        glVertex3f(-r, r,-r);
        glVertex3f( r, r,-r);
        glVertex3f( r,-r,-r);
        glVertex3f(-r,-r,-r);
    
        // face gauche :
        glNormal3f(-1,0,0);
        glVertex3f(-r,-r, r);
        glVertex3f(-r, r, r);
        glVertex3f(-r, r,-r);
        glVertex3f(-r,-r,-r);
                                       
        // face droite :           
        glNormal3f(1,0,0);
        glVertex3f( r,-r,-r);
        glVertex3f( r, r,-r);
        glVertex3f( r, r, r);
        glVertex3f( r,-r, r);
                                       
        // face avant :            
        glNormal3f(0,-1,0);
        glVertex3f(-r,-r,-r);
        glVertex3f( r,-r,-r);
        glVertex3f( r,-r, r);
        glVertex3f(-r,-r, r);
                                       
        // face arrire :          
        glNormal3f(0,1,0);
        glVertex3f(-r, r, r);
        glVertex3f( r, r, r);
        glVertex3f( r, r,-r);
        glVertex3f(-r, r,-r);
    glEnd();
    }

/*********************************************************************************************/
// RenderableTeapot implementation :

float RenderableTeapot::radius() const { return 1.5f * r; }

void RenderableTeapot::render() const {
    glutSolidTeapot(r);
    }
        
}

