#ifndef __TEXTURE_SET__
#define __TEXTURE_SET__

#include "Texture.h"
#include <QList>

namespace apig {

    // cette classe reprsente un ensemble de textures destinees a tre activees en mme temps
    // la destruction des textures n'est pas prise en charge par la classe
    class TextureSet {
        public:
            TextureSet() {}
            int add(Texture* texture);      // retourne le numero de texture
            void load() const;              // charge les textures de la liste en memoire video
            void activate() const;          // active les textures
            void deactivate() const;        // desactive les textures
            void clear();                   // supprime toutes les textures de la liste
        private:
            QList<Texture*> list;
        };
    
    }

#endif

