#include "Util.h"
#include <QDir>

namespace apig {
    namespace util {
        QString filePath(QString dirName, QString fileName) {
            return QDir::cleanPath(QDir(dirName).filePath(fileName));
            }
        
        QStringList subDirsList(QString dirName) {
            QDir dir(dirName);
            return dir.entryList(QDir::Dirs | QDir::NoDotAndDotDot, QDir::Name);
            }

        int max(int a, int b) {
            return a > b ? a : b;
            }

        int min(int a, int b) {
            return a < b ? a : b;
            }

        int clamp(int x, int xmin, int xmax) {
            return min(max(x, xmin), xmax);
            }

        int modulo(int x, int m) {
            return x >= 0 ? x % m : m + x % m;
            }

        int mirror(int x, int m) {
            const int a = modulo(x, 2*m);
            return (a < m) ? a : 2*m - 1 - a;
            }
        }
    }

